// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/match_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fmatch_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fmatch_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/match_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// MatchService is a Google managed service for efficient vector similarity
// search at scale.
class MatchService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.MatchService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Finds the nearest neighbors of each vector within the request.
    virtual ::grpc::Status FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>> AsyncFindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>>(AsyncFindNeighborsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>> PrepareAsyncFindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>>(PrepareAsyncFindNeighborsRaw(context, request, cq));
    }
    // Reads the datapoints/vectors of the given IDs.
    // A maximum of 1000 datapoints can be retrieved in a batch.
    virtual ::grpc::Status ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>> AsyncReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>>(AsyncReadIndexDatapointsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>> PrepareAsyncReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>>(PrepareAsyncReadIndexDatapointsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Finds the nearest neighbors of each vector within the request.
      virtual void FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reads the datapoints/vectors of the given IDs.
      // A maximum of 1000 datapoints can be retrieved in a batch.
      virtual void ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>* AsyncFindNeighborsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::FindNeighborsResponse>* PrepareAsyncFindNeighborsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* AsyncReadIndexDatapointsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* PrepareAsyncReadIndexDatapointsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>> AsyncFindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>>(AsyncFindNeighborsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>> PrepareAsyncFindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>>(PrepareAsyncFindNeighborsRaw(context, request, cq));
    }
    ::grpc::Status ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>> AsyncReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>>(AsyncReadIndexDatapointsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>> PrepareAsyncReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>>(PrepareAsyncReadIndexDatapointsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response, std::function<void(::grpc::Status)>) override;
      void FindNeighbors(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response, std::function<void(::grpc::Status)>) override;
      void ReadIndexDatapoints(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>* AsyncFindNeighborsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::FindNeighborsResponse>* PrepareAsyncFindNeighborsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* AsyncReadIndexDatapointsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* PrepareAsyncReadIndexDatapointsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_FindNeighbors_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadIndexDatapoints_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Finds the nearest neighbors of each vector within the request.
    virtual ::grpc::Status FindNeighbors(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response);
    // Reads the datapoints/vectors of the given IDs.
    // A maximum of 1000 datapoints can be retrieved in a batch.
    virtual ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFindNeighbors(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::FindNeighborsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadIndexDatapoints(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_FindNeighbors<WithAsyncMethod_ReadIndexDatapoints<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::FindNeighborsRequest, ::google::cloud::aiplatform::v1::FindNeighborsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* request, ::google::cloud::aiplatform::v1::FindNeighborsResponse* response) { return this->FindNeighbors(context, request, response); }));}
    void SetMessageAllocatorFor_FindNeighbors(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::FindNeighborsRequest, ::google::cloud::aiplatform::v1::FindNeighborsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::FindNeighborsRequest, ::google::cloud::aiplatform::v1::FindNeighborsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FindNeighbors(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* request, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* response) { return this->ReadIndexDatapoints(context, request, response); }));}
    void SetMessageAllocatorFor_ReadIndexDatapoints(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReadIndexDatapoints(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_FindNeighbors<WithCallbackMethod_ReadIndexDatapoints<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFindNeighbors(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadIndexDatapoints(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FindNeighbors(context, request, response); }));
    }
    ~WithRawCallbackMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FindNeighbors(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReadIndexDatapoints(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReadIndexDatapoints(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FindNeighbors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FindNeighbors() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::FindNeighborsRequest, ::google::cloud::aiplatform::v1::FindNeighborsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::FindNeighborsRequest, ::google::cloud::aiplatform::v1::FindNeighborsResponse>* streamer) {
                       return this->StreamedFindNeighbors(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FindNeighbors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FindNeighbors(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::FindNeighborsRequest* /*request*/, ::google::cloud::aiplatform::v1::FindNeighborsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFindNeighbors(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::FindNeighborsRequest,::google::cloud::aiplatform::v1::FindNeighborsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReadIndexDatapoints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReadIndexDatapoints() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* streamer) {
                       return this->StreamedReadIndexDatapoints(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReadIndexDatapoints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadIndexDatapoints(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest* /*request*/, ::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReadIndexDatapoints(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ReadIndexDatapointsRequest,::google::cloud::aiplatform::v1::ReadIndexDatapointsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_FindNeighbors<WithStreamedUnaryMethod_ReadIndexDatapoints<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_FindNeighbors<WithStreamedUnaryMethod_ReadIndexDatapoints<Service > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fmatch_5fservice_2eproto__INCLUDED
