// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataproc/v1/batches.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataproc_2fv1_2fbatches_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataproc_2fv1_2fbatches_2eproto__INCLUDED

#include "google/cloud/dataproc/v1/batches.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataproc {
namespace v1 {

// The BatchController provides methods to manage batch workloads.
class BatchController final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataproc.v1.BatchController";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a batch workload that executes asynchronously.
    virtual ::grpc::Status CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateBatchRaw(context, request, cq));
    }
    // Gets the batch workload resource representation.
    virtual ::grpc::Status GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::google::cloud::dataproc::v1::Batch* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>> AsyncGetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>>(AsyncGetBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>> PrepareAsyncGetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>>(PrepareAsyncGetBatchRaw(context, request, cq));
    }
    // Lists batch workloads.
    virtual ::grpc::Status ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::google::cloud::dataproc::v1::ListBatchesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>> AsyncListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>>(AsyncListBatchesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>> PrepareAsyncListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>>(PrepareAsyncListBatchesRaw(context, request, cq));
    }
    // Deletes the batch workload resource. If the batch is not in terminal state,
    // the delete fails and the response returns `FAILED_PRECONDITION`.
    virtual ::grpc::Status DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteBatchRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a batch workload that executes asynchronously.
      virtual void CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the batch workload resource representation.
      virtual void GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists batch workloads.
      virtual void ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the batch workload resource. If the batch is not in terminal state,
      // the delete fails and the response returns `FAILED_PRECONDITION`.
      virtual void DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>* AsyncGetBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Batch>* PrepareAsyncGetBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>* AsyncListBatchesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListBatchesResponse>* PrepareAsyncListBatchesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateBatchRaw(context, request, cq));
    }
    ::grpc::Status GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::google::cloud::dataproc::v1::Batch* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>> AsyncGetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>>(AsyncGetBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>> PrepareAsyncGetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>>(PrepareAsyncGetBatchRaw(context, request, cq));
    }
    ::grpc::Status ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::google::cloud::dataproc::v1::ListBatchesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>> AsyncListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>>(AsyncListBatchesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>> PrepareAsyncListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>>(PrepareAsyncListBatchesRaw(context, request, cq));
    }
    ::grpc::Status DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteBatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteBatchRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response, std::function<void(::grpc::Status)>) override;
      void GetBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBatches(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteBatch(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>* AsyncGetBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Batch>* PrepareAsyncGetBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>* AsyncListBatchesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListBatchesResponse>* PrepareAsyncListBatchesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteBatchRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBatch_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBatch_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBatches_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBatch_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a batch workload that executes asynchronously.
    virtual ::grpc::Status CreateBatch(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response);
    // Gets the batch workload resource representation.
    virtual ::grpc::Status GetBatch(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response);
    // Lists batch workloads.
    virtual ::grpc::Status ListBatches(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response);
    // Deletes the batch workload resource. If the batch is not in terminal state,
    // the delete fails and the response returns `FAILED_PRECONDITION`.
    virtual ::grpc::Status DeleteBatch(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBatch() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBatch(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBatch() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBatch(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::GetBatchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::Batch>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBatches() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBatches(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::ListBatchesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBatch(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateBatch<WithAsyncMethod_GetBatch<WithAsyncMethod_ListBatches<WithAsyncMethod_DeleteBatch<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBatch() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateBatchRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::CreateBatchRequest* request, ::google::longrunning::Operation* response) { return this->CreateBatch(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBatch(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::CreateBatchRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateBatchRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBatch() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetBatchRequest, ::google::cloud::dataproc::v1::Batch>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::GetBatchRequest* request, ::google::cloud::dataproc::v1::Batch* response) { return this->GetBatch(context, request, response); }));}
    void SetMessageAllocatorFor_GetBatch(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::GetBatchRequest, ::google::cloud::dataproc::v1::Batch>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetBatchRequest, ::google::cloud::dataproc::v1::Batch>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBatches() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListBatchesRequest, ::google::cloud::dataproc::v1::ListBatchesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::ListBatchesRequest* request, ::google::cloud::dataproc::v1::ListBatchesResponse* response) { return this->ListBatches(context, request, response); }));}
    void SetMessageAllocatorFor_ListBatches(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::ListBatchesRequest, ::google::cloud::dataproc::v1::ListBatchesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListBatchesRequest, ::google::cloud::dataproc::v1::ListBatchesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBatches(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteBatchRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::DeleteBatchRequest* request, ::google::protobuf::Empty* response) { return this->DeleteBatch(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBatch(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::DeleteBatchRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteBatchRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateBatch<WithCallbackMethod_GetBatch<WithCallbackMethod_ListBatches<WithCallbackMethod_DeleteBatch<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBatch() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBatch() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBatches() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBatch() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBatch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBatch() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBatch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBatches() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBatches(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBatch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBatch() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBatch(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBatch() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBatch(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBatches() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBatches(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBatches(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBatch(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBatch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBatch() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::CreateBatchRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::CreateBatchRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateBatch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateBatchRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBatch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::CreateBatchRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBatch() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::GetBatchRequest, ::google::cloud::dataproc::v1::Batch>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::GetBatchRequest, ::google::cloud::dataproc::v1::Batch>* streamer) {
                       return this->StreamedGetBatch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetBatchRequest* /*request*/, ::google::cloud::dataproc::v1::Batch* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBatch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::GetBatchRequest,::google::cloud::dataproc::v1::Batch>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBatches : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBatches() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::ListBatchesRequest, ::google::cloud::dataproc::v1::ListBatchesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::ListBatchesRequest, ::google::cloud::dataproc::v1::ListBatchesResponse>* streamer) {
                       return this->StreamedListBatches(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBatches() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBatches(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListBatchesRequest* /*request*/, ::google::cloud::dataproc::v1::ListBatchesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBatches(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::ListBatchesRequest,::google::cloud::dataproc::v1::ListBatchesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBatch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBatch() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::DeleteBatchRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::DeleteBatchRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteBatch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBatch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBatch(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteBatchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBatch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::DeleteBatchRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateBatch<WithStreamedUnaryMethod_GetBatch<WithStreamedUnaryMethod_ListBatches<WithStreamedUnaryMethod_DeleteBatch<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateBatch<WithStreamedUnaryMethod_GetBatch<WithStreamedUnaryMethod_ListBatches<WithStreamedUnaryMethod_DeleteBatch<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace dataproc
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataproc_2fv1_2fbatches_2eproto__INCLUDED
