// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataproc/v1/node_groups.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataproc_2fv1_2fnode_5fgroups_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataproc_2fv1_2fnode_5fgroups_2eproto__INCLUDED

#include "google/cloud/dataproc/v1/node_groups.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataproc {
namespace v1 {

// The `NodeGroupControllerService` provides methods to manage node groups
// of Compute Engine managed instances.
class NodeGroupController final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataproc.v1.NodeGroupController";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a node group in a cluster. The returned
    // [Operation.metadata][google.longrunning.Operation.metadata] is
    // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
    virtual ::grpc::Status CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNodeGroupRaw(context, request, cq));
    }
    // Resizes a node group in a cluster. The returned
    // [Operation.metadata][google.longrunning.Operation.metadata] is
    // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
    virtual ::grpc::Status ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResizeNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResizeNodeGroupRaw(context, request, cq));
    }
    // Gets the resource representation for a node group in a
    // cluster.
    virtual ::grpc::Status GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::google::cloud::dataproc::v1::NodeGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>> AsyncGetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>>(AsyncGetNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>> PrepareAsyncGetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>>(PrepareAsyncGetNodeGroupRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a node group in a cluster. The returned
      // [Operation.metadata][google.longrunning.Operation.metadata] is
      // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
      virtual void CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resizes a node group in a cluster. The returned
      // [Operation.metadata][google.longrunning.Operation.metadata] is
      // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
      virtual void ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the resource representation for a node group in a
      // cluster.
      virtual void GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResizeNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResizeNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>* AsyncGetNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::NodeGroup>* PrepareAsyncGetNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNodeGroupRaw(context, request, cq));
    }
    ::grpc::Status ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResizeNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResizeNodeGroupRaw(context, request, cq));
    }
    ::grpc::Status GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::google::cloud::dataproc::v1::NodeGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>> AsyncGetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>>(AsyncGetNodeGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>> PrepareAsyncGetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>>(PrepareAsyncGetNodeGroupRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResizeNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response, std::function<void(::grpc::Status)>) override;
      void GetNodeGroup(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResizeNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResizeNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>* AsyncGetNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::NodeGroup>* PrepareAsyncGetNodeGroupRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNodeGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_ResizeNodeGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNodeGroup_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a node group in a cluster. The returned
    // [Operation.metadata][google.longrunning.Operation.metadata] is
    // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
    virtual ::grpc::Status CreateNodeGroup(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response);
    // Resizes a node group in a cluster. The returned
    // [Operation.metadata][google.longrunning.Operation.metadata] is
    // [NodeGroupOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#nodegroupoperationmetadata).
    virtual ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response);
    // Gets the resource representation for a node group in a
    // cluster.
    virtual ::grpc::Status GetNodeGroup(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNodeGroup(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResizeNodeGroup(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeGroup(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::NodeGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateNodeGroup<WithAsyncMethod_ResizeNodeGroup<WithAsyncMethod_GetNodeGroup<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateNodeGroupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* request, ::google::longrunning::Operation* response) { return this->CreateNodeGroup(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNodeGroup(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::CreateNodeGroupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateNodeGroupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ResizeNodeGroupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* request, ::google::longrunning::Operation* response) { return this->ResizeNodeGroup(context, request, response); }));}
    void SetMessageAllocatorFor_ResizeNodeGroup(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::ResizeNodeGroupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ResizeNodeGroupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResizeNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetNodeGroupRequest, ::google::cloud::dataproc::v1::NodeGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* request, ::google::cloud::dataproc::v1::NodeGroup* response) { return this->GetNodeGroup(context, request, response); }));}
    void SetMessageAllocatorFor_GetNodeGroup(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::GetNodeGroupRequest, ::google::cloud::dataproc::v1::NodeGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetNodeGroupRequest, ::google::cloud::dataproc::v1::NodeGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateNodeGroup<WithCallbackMethod_ResizeNodeGroup<WithCallbackMethod_GetNodeGroup<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNodeGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResizeNodeGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNodeGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResizeNodeGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResizeNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNodeGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNodeGroup() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::CreateNodeGroupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::CreateNodeGroupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNodeGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNodeGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::CreateNodeGroupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResizeNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResizeNodeGroup() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::ResizeNodeGroupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::ResizeNodeGroupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResizeNodeGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResizeNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResizeNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ResizeNodeGroupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResizeNodeGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::ResizeNodeGroupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNodeGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNodeGroup() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::GetNodeGroupRequest, ::google::cloud::dataproc::v1::NodeGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::GetNodeGroupRequest, ::google::cloud::dataproc::v1::NodeGroup>* streamer) {
                       return this->StreamedGetNodeGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNodeGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNodeGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetNodeGroupRequest* /*request*/, ::google::cloud::dataproc::v1::NodeGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNodeGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::GetNodeGroupRequest,::google::cloud::dataproc::v1::NodeGroup>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateNodeGroup<WithStreamedUnaryMethod_ResizeNodeGroup<WithStreamedUnaryMethod_GetNodeGroup<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateNodeGroup<WithStreamedUnaryMethod_ResizeNodeGroup<WithStreamedUnaryMethod_GetNodeGroup<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace dataproc
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataproc_2fv1_2fnode_5fgroups_2eproto__INCLUDED
