// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/conversation_profile.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTERNAL_CONVERSATION_PROFILES_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTERNAL_CONVERSATION_PROFILES_STUB_H

#include "google/cloud/completion_queue.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/dialogflow/v2/conversation_profile.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace dialogflow_es_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ConversationProfilesStub {
 public:
  virtual ~ConversationProfilesStub() = 0;

  virtual StatusOr<
      google::cloud::dialogflow::v2::ListConversationProfilesResponse>
  ListConversationProfiles(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::ListConversationProfilesRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  GetConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::GetConversationProfileRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  CreateConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::CreateConversationProfileRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  UpdateConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::UpdateConversationProfileRequest const&
          request) = 0;

  virtual Status DeleteConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::DeleteConversationProfileRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncSetSuggestionFeatureConfig(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::v2::SetSuggestionFeatureConfigRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> SetSuggestionFeatureConfig(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::v2::SetSuggestionFeatureConfigRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncClearSuggestionFeatureConfig(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::v2::ClearSuggestionFeatureConfigRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> ClearSuggestionFeatureConfig(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::v2::ClearSuggestionFeatureConfigRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultConversationProfilesStub : public ConversationProfilesStub {
 public:
  DefaultConversationProfilesStub(
      std::unique_ptr<
          google::cloud::dialogflow::v2::ConversationProfiles::StubInterface>
          grpc_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations)
      : grpc_stub_(std::move(grpc_stub)), operations_(std::move(operations)) {}

  StatusOr<google::cloud::dialogflow::v2::ListConversationProfilesResponse>
  ListConversationProfiles(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::ListConversationProfilesRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  GetConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::GetConversationProfileRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  CreateConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::CreateConversationProfileRequest const&
          request) override;

  StatusOr<google::cloud::dialogflow::v2::ConversationProfile>
  UpdateConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::UpdateConversationProfileRequest const&
          request) override;

  Status DeleteConversationProfile(
      grpc::ClientContext& context, Options const& options,
      google::cloud::dialogflow::v2::DeleteConversationProfileRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncSetSuggestionFeatureConfig(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::v2::SetSuggestionFeatureConfigRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> SetSuggestionFeatureConfig(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::v2::SetSuggestionFeatureConfigRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncClearSuggestionFeatureConfig(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::dialogflow::v2::ClearSuggestionFeatureConfigRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> ClearSuggestionFeatureConfig(
      grpc::ClientContext& context, Options options,
      google::cloud::dialogflow::v2::ClearSuggestionFeatureConfigRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<
      google::cloud::dialogflow::v2::ConversationProfiles::StubInterface>
      grpc_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface> operations_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTERNAL_CONVERSATION_PROFILES_STUB_H
