// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/engine_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_ENGINE_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_ENGINE_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/discoveryengine/v1/engine_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace discoveryengine_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class EngineServiceConnectionIdempotencyPolicy {
 public:
  virtual ~EngineServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<EngineServiceConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency CreateEngine(
      google::cloud::discoveryengine::v1::CreateEngineRequest const& request);

  virtual google::cloud::Idempotency DeleteEngine(
      google::cloud::discoveryengine::v1::DeleteEngineRequest const& request);

  virtual google::cloud::Idempotency UpdateEngine(
      google::cloud::discoveryengine::v1::UpdateEngineRequest const& request);

  virtual google::cloud::Idempotency GetEngine(
      google::cloud::discoveryengine::v1::GetEngineRequest const& request);

  virtual google::cloud::Idempotency ListEngines(
      google::cloud::discoveryengine::v1::ListEnginesRequest request);
};

std::unique_ptr<EngineServiceConnectionIdempotencyPolicy>
MakeDefaultEngineServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_ENGINE_CONNECTION_IDEMPOTENCY_POLICY_H
