// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/completion_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_AUTH_DECORATOR_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_AUTH_DECORATOR_H

#include "google/cloud/discoveryengine/v1/internal/completion_stub.h"
#include "google/cloud/internal/unified_grpc_credentials.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <set>
#include <string>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CompletionServiceAuth : public CompletionServiceStub {
 public:
  ~CompletionServiceAuth() override = default;
  CompletionServiceAuth(
      std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth,
      std::shared_ptr<CompletionServiceStub> child);

  StatusOr<google::cloud::discoveryengine::v1::CompleteQueryResponse>
  CompleteQuery(grpc::ClientContext& context, Options const& options,
                google::cloud::discoveryengine::v1::CompleteQueryRequest const&
                    request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncImportSuggestionDenyListEntries(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::
          ImportSuggestionDenyListEntriesRequest const& request) override;

  StatusOr<google::longrunning::Operation> ImportSuggestionDenyListEntries(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::
          ImportSuggestionDenyListEntriesRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncPurgeSuggestionDenyListEntries(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::
          PurgeSuggestionDenyListEntriesRequest const& request) override;

  StatusOr<google::longrunning::Operation> PurgeSuggestionDenyListEntries(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::
          PurgeSuggestionDenyListEntriesRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncImportCompletionSuggestions(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::
          ImportCompletionSuggestionsRequest const& request) override;

  StatusOr<google::longrunning::Operation> ImportCompletionSuggestions(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::
          ImportCompletionSuggestionsRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncPurgeCompletionSuggestions(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::
          PurgeCompletionSuggestionsRequest const& request) override;

  StatusOr<google::longrunning::Operation> PurgeCompletionSuggestions(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::
          PurgeCompletionSuggestionsRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth_;
  std::shared_ptr<CompletionServiceStub> child_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_AUTH_DECORATOR_H
