// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/iap/v1/service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAP_V1_MOCKS_MOCK_IDENTITY_AWARE_PROXY_O_AUTH_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAP_V1_MOCKS_MOCK_IDENTITY_AWARE_PROXY_O_AUTH_CONNECTION_H

#include "google/cloud/iap/v1/identity_aware_proxy_o_auth_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace iap_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `IdentityAwareProxyOAuthServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type
 * `IdentityAwareProxyOAuthServiceClient`. To do so, construct an object of type
 * `IdentityAwareProxyOAuthServiceClient` with an instance of this class. Then
 * use the Google Test framework functions to program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockIdentityAwareProxyOAuthServiceConnection
    : public iap_v1::IdentityAwareProxyOAuthServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(StatusOr<google::cloud::iap::v1::ListBrandsResponse>, ListBrands,
              (google::cloud::iap::v1::ListBrandsRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::iap::v1::Brand>, CreateBrand,
              (google::cloud::iap::v1::CreateBrandRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::iap::v1::Brand>, GetBrand,
              (google::cloud::iap::v1::GetBrandRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::iap::v1::IdentityAwareProxyClient>,
      CreateIdentityAwareProxyClient,
      (google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest const&
           request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::iap::v1::IdentityAwareProxyClient>),
      ListIdentityAwareProxyClients,
      (google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::iap::v1::IdentityAwareProxyClient>,
              GetIdentityAwareProxyClient,
              (google::cloud::iap::v1::GetIdentityAwareProxyClientRequest const&
                   request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::iap::v1::IdentityAwareProxyClient>,
      ResetIdentityAwareProxyClientSecret,
      (google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest const&
           request),
      (override));

  MOCK_METHOD(
      Status, DeleteIdentityAwareProxyClient,
      (google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest const&
           request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace iap_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAP_V1_MOCKS_MOCK_IDENTITY_AWARE_PROXY_O_AUTH_CONNECTION_H
