// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networkconnectivity/v1/policy_based_routing.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fpolicy_5fbased_5frouting_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fpolicy_5fbased_5frouting_2eproto__INCLUDED

#include "google/cloud/networkconnectivity/v1/policy_based_routing.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace networkconnectivity {
namespace v1 {

// Policy-Based Routing allows GCP customers to specify flexibile routing
// policies for Layer 4 traffic traversing through the connected service.
class PolicyBasedRoutingService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networkconnectivity.v1.PolicyBasedRoutingService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists PolicyBasedRoutes in a given project and location.
    virtual ::grpc::Status ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>> AsyncListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>>(AsyncListPolicyBasedRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>> PrepareAsyncListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>>(PrepareAsyncListPolicyBasedRoutesRaw(context, request, cq));
    }
    // Gets details of a single PolicyBasedRoute.
    virtual ::grpc::Status GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>> AsyncGetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>>(AsyncGetPolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>> PrepareAsyncGetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>>(PrepareAsyncGetPolicyBasedRouteRaw(context, request, cq));
    }
    // Creates a new PolicyBasedRoute in a given project and location.
    virtual ::grpc::Status CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePolicyBasedRouteRaw(context, request, cq));
    }
    // Deletes a single PolicyBasedRoute.
    virtual ::grpc::Status DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePolicyBasedRouteRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists PolicyBasedRoutes in a given project and location.
      virtual void ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single PolicyBasedRoute.
      virtual void GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new PolicyBasedRoute in a given project and location.
      virtual void CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single PolicyBasedRoute.
      virtual void DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* AsyncListPolicyBasedRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* PrepareAsyncListPolicyBasedRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* AsyncGetPolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* PrepareAsyncGetPolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>> AsyncListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>>(AsyncListPolicyBasedRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>> PrepareAsyncListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>>(PrepareAsyncListPolicyBasedRoutesRaw(context, request, cq));
    }
    ::grpc::Status GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>> AsyncGetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>>(AsyncGetPolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>> PrepareAsyncGetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>>(PrepareAsyncGetPolicyBasedRouteRaw(context, request, cq));
    }
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePolicyBasedRouteRaw(context, request, cq));
    }
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePolicyBasedRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePolicyBasedRouteRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPolicyBasedRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response, std::function<void(::grpc::Status)>) override;
      void GetPolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePolicyBasedRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* AsyncListPolicyBasedRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* PrepareAsyncListPolicyBasedRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* AsyncGetPolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* PrepareAsyncGetPolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePolicyBasedRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListPolicyBasedRoutes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPolicyBasedRoute_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePolicyBasedRoute_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePolicyBasedRoute_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists PolicyBasedRoutes in a given project and location.
    virtual ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response);
    // Gets details of a single PolicyBasedRoute.
    virtual ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response);
    // Creates a new PolicyBasedRoute in a given project and location.
    virtual ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single PolicyBasedRoute.
    virtual ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyBasedRoutes(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyBasedRoute(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyBasedRoute(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyBasedRoute(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListPolicyBasedRoutes<WithAsyncMethod_GetPolicyBasedRoute<WithAsyncMethod_CreatePolicyBasedRoute<WithAsyncMethod_DeletePolicyBasedRoute<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* response) { return this->ListPolicyBasedRoutes(context, request, response); }));}
    void SetMessageAllocatorFor_ListPolicyBasedRoutes(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyBasedRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* request, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* response) { return this->GetPolicyBasedRoute(context, request, response); }));}
    void SetMessageAllocatorFor_GetPolicyBasedRoute(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response) { return this->CreatePolicyBasedRoute(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePolicyBasedRoute(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* request, ::google::longrunning::Operation* response) { return this->DeletePolicyBasedRoute(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePolicyBasedRoute(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListPolicyBasedRoutes<WithCallbackMethod_GetPolicyBasedRoute<WithCallbackMethod_CreatePolicyBasedRoute<WithCallbackMethod_DeletePolicyBasedRoute<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyBasedRoutes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPolicyBasedRoutes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyBasedRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPolicyBasedRoute(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePolicyBasedRoute(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePolicyBasedRoute(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyBasedRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPolicyBasedRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPolicyBasedRoutes() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* streamer) {
                       return this->StreamedListPolicyBasedRoutes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPolicyBasedRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPolicyBasedRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPolicyBasedRoutes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest,::google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPolicyBasedRoute() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* streamer) {
                       return this->StreamedGetPolicyBasedRoute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::PolicyBasedRoute* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest,::google::cloud::networkconnectivity::v1::PolicyBasedRoute>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePolicyBasedRoute() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePolicyBasedRoute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::CreatePolicyBasedRouteRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePolicyBasedRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePolicyBasedRoute() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePolicyBasedRoute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePolicyBasedRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePolicyBasedRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePolicyBasedRoute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::DeletePolicyBasedRouteRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListPolicyBasedRoutes<WithStreamedUnaryMethod_GetPolicyBasedRoute<WithStreamedUnaryMethod_CreatePolicyBasedRoute<WithStreamedUnaryMethod_DeletePolicyBasedRoute<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListPolicyBasedRoutes<WithStreamedUnaryMethod_GetPolicyBasedRoute<WithStreamedUnaryMethod_CreatePolicyBasedRoute<WithStreamedUnaryMethod_DeletePolicyBasedRoute<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace networkconnectivity
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fpolicy_5fbased_5frouting_2eproto__INCLUDED
