// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/privilegedaccessmanager/v1/privilegedaccessmanager.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fprivilegedaccessmanager_2fv1_2fprivilegedaccessmanager_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fprivilegedaccessmanager_2fv1_2fprivilegedaccessmanager_2eproto__INCLUDED

#include "google/cloud/privilegedaccessmanager/v1/privilegedaccessmanager.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace privilegedaccessmanager {
namespace v1 {

// This API allows customers to manage temporary, request based privileged
// access to their resources.
//
// It defines the following resource model:
//
// * A collection of `Entitlement` resources. An entitlement allows configuring
//   (among other things):
//
//   * Some kind of privileged access that users can request.
//   * A set of users called _requesters_ who can request this access.
//   * A maximum duration for which the access can be requested.
//   * An optional approval workflow which must be satisfied before access is
//     granted.
//
// * A collection of `Grant` resources. A grant is a request by a requester to
//   get the privileged access specified in an entitlement for some duration.
//
//   After the approval workflow as specified in the entitlement is satisfied,
//   the specified access is given to the requester. The access is automatically
//   taken back after the requested duration is over.
class PrivilegedAccessManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.privilegedaccessmanager.v1.PrivilegedAccessManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // CheckOnboardingStatus reports the onboarding status for a
    // project/folder/organization. Any findings reported by this API need to be
    // fixed before PAM can be used on the resource.
    virtual ::grpc::Status CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>> AsyncCheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>>(AsyncCheckOnboardingStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>> PrepareAsyncCheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>>(PrepareAsyncCheckOnboardingStatusRaw(context, request, cq));
    }
    // Lists entitlements in a given project/folder/organization and location.
    virtual ::grpc::Status ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>> AsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>>(AsyncListEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>> PrepareAsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>>(PrepareAsyncListEntitlementsRaw(context, request, cq));
    }
    // `SearchEntitlements` returns entitlements on which the caller has the
    // specified access.
    virtual ::grpc::Status SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>> AsyncSearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>>(AsyncSearchEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>> PrepareAsyncSearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>>(PrepareAsyncSearchEntitlementsRaw(context, request, cq));
    }
    // Gets details of a single entitlement.
    virtual ::grpc::Status GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>> AsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>>(AsyncGetEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>> PrepareAsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>>(PrepareAsyncGetEntitlementRaw(context, request, cq));
    }
    // Creates a new entitlement in a given project/folder/organization and
    // location.
    virtual ::grpc::Status CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateEntitlementRaw(context, request, cq));
    }
    // Deletes a single entitlement. This method can only be called when there
    // are no in-progress (ACTIVE/ACTIVATING/REVOKING) grants under the
    // entitlement.
    virtual ::grpc::Status DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteEntitlementRaw(context, request, cq));
    }
    // Updates the entitlement specified in the request. Updated fields in the
    // entitlement need to be specified in an update mask. The changes made to an
    // entitlement are applicable only on future grants of the entitlement.
    // However, if new approvers are added or existing approvers are removed from
    // the approval workflow, the changes are effective on existing grants.
    //
    // The following fields are not supported for updates:
    //
    //  * All immutable fields
    //  * Entitlement name
    //  * Resource name
    //  * Resource type
    //  * Adding an approval workflow in an entitlement which previously had no
    //    approval workflow.
    //  * Deleting the approval workflow from an entitlement.
    //  * Adding or deleting a step in the approval workflow (only one step is
    //    supported)
    //
    // Note that updates are allowed on the list of approvers in an approval
    // workflow step.
    virtual ::grpc::Status UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateEntitlementRaw(context, request, cq));
    }
    // Lists grants for a given entitlement.
    virtual ::grpc::Status ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>> AsyncListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>>(AsyncListGrantsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>> PrepareAsyncListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>>(PrepareAsyncListGrantsRaw(context, request, cq));
    }
    // `SearchGrants` returns grants that are related to the calling user in the
    // specified way.
    virtual ::grpc::Status SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>> AsyncSearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>>(AsyncSearchGrantsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>> PrepareAsyncSearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>>(PrepareAsyncSearchGrantsRaw(context, request, cq));
    }
    // Get details of a single grant.
    virtual ::grpc::Status GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncGetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncGetGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncGetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncGetGrantRaw(context, request, cq));
    }
    // Creates a new grant in a given project and location.
    virtual ::grpc::Status CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncCreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncCreateGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncCreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncCreateGrantRaw(context, request, cq));
    }
    // `ApproveGrant` is used to approve a grant. This method can only be called
    // on a grant when it's in the `APPROVAL_AWAITED` state. This operation can't
    // be undone.
    virtual ::grpc::Status ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncApproveGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncApproveGrantRaw(context, request, cq));
    }
    // `DenyGrant` is used to deny a grant. This method can only be called on a
    // grant when it's in the `APPROVAL_AWAITED` state. This operation can't be
    // undone.
    virtual ::grpc::Status DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncDenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncDenyGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncDenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncDenyGrantRaw(context, request, cq));
    }
    // `RevokeGrant` is used to immediately revoke access for a grant. This method
    // can be called when the grant is in a non-terminal state.
    virtual ::grpc::Status RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRevokeGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRevokeGrantRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // CheckOnboardingStatus reports the onboarding status for a
      // project/folder/organization. Any findings reported by this API need to be
      // fixed before PAM can be used on the resource.
      virtual void CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists entitlements in a given project/folder/organization and location.
      virtual void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `SearchEntitlements` returns entitlements on which the caller has the
      // specified access.
      virtual void SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single entitlement.
      virtual void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new entitlement in a given project/folder/organization and
      // location.
      virtual void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single entitlement. This method can only be called when there
      // are no in-progress (ACTIVE/ACTIVATING/REVOKING) grants under the
      // entitlement.
      virtual void DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the entitlement specified in the request. Updated fields in the
      // entitlement need to be specified in an update mask. The changes made to an
      // entitlement are applicable only on future grants of the entitlement.
      // However, if new approvers are added or existing approvers are removed from
      // the approval workflow, the changes are effective on existing grants.
      //
      // The following fields are not supported for updates:
      //
      //  * All immutable fields
      //  * Entitlement name
      //  * Resource name
      //  * Resource type
      //  * Adding an approval workflow in an entitlement which previously had no
      //    approval workflow.
      //  * Deleting the approval workflow from an entitlement.
      //  * Adding or deleting a step in the approval workflow (only one step is
      //    supported)
      //
      // Note that updates are allowed on the list of approvers in an approval
      // workflow step.
      virtual void UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists grants for a given entitlement.
      virtual void ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `SearchGrants` returns grants that are related to the calling user in the
      // specified way.
      virtual void SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get details of a single grant.
      virtual void GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new grant in a given project and location.
      virtual void CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `ApproveGrant` is used to approve a grant. This method can only be called
      // on a grant when it's in the `APPROVAL_AWAITED` state. This operation can't
      // be undone.
      virtual void ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `DenyGrant` is used to deny a grant. This method can only be called on a
      // grant when it's in the `APPROVAL_AWAITED` state. This operation can't be
      // undone.
      virtual void DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `RevokeGrant` is used to immediately revoke access for a grant. This method
      // can be called when the grant is in a non-terminal state.
      virtual void RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* AsyncCheckOnboardingStatusRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* PrepareAsyncCheckOnboardingStatusRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* AsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* PrepareAsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* AsyncSearchEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* PrepareAsyncSearchEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>* AsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Entitlement>* PrepareAsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* AsyncListGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* PrepareAsyncListGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* AsyncSearchGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* PrepareAsyncSearchGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncGetGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncGetGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncCreateGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncCreateGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncApproveGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncApproveGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncDenyGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncDenyGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRevokeGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRevokeGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>> AsyncCheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>>(AsyncCheckOnboardingStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>> PrepareAsyncCheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>>(PrepareAsyncCheckOnboardingStatusRaw(context, request, cq));
    }
    ::grpc::Status ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>> AsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>>(AsyncListEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>> PrepareAsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>>(PrepareAsyncListEntitlementsRaw(context, request, cq));
    }
    ::grpc::Status SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>> AsyncSearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>>(AsyncSearchEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>> PrepareAsyncSearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>>(PrepareAsyncSearchEntitlementsRaw(context, request, cq));
    }
    ::grpc::Status GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>> AsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>>(AsyncGetEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>> PrepareAsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>>(PrepareAsyncGetEntitlementRaw(context, request, cq));
    }
    ::grpc::Status CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateEntitlementRaw(context, request, cq));
    }
    ::grpc::Status DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteEntitlementRaw(context, request, cq));
    }
    ::grpc::Status UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateEntitlementRaw(context, request, cq));
    }
    ::grpc::Status ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>> AsyncListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>>(AsyncListGrantsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>> PrepareAsyncListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>>(PrepareAsyncListGrantsRaw(context, request, cq));
    }
    ::grpc::Status SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>> AsyncSearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>>(AsyncSearchGrantsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>> PrepareAsyncSearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>>(PrepareAsyncSearchGrantsRaw(context, request, cq));
    }
    ::grpc::Status GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncGetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncGetGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncGetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncGetGrantRaw(context, request, cq));
    }
    ::grpc::Status CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncCreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncCreateGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncCreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncCreateGrantRaw(context, request, cq));
    }
    ::grpc::Status ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncApproveGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncApproveGrantRaw(context, request, cq));
    }
    ::grpc::Status DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> AsyncDenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(AsyncDenyGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>> PrepareAsyncDenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>>(PrepareAsyncDenyGrantRaw(context, request, cq));
    }
    ::grpc::Status RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRevokeGrantRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRevokeGrantRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response, std::function<void(::grpc::Status)>) override;
      void CheckOnboardingStatus(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchEntitlements(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response, std::function<void(::grpc::Status)>) override;
      void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntitlement(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchGrants(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) override;
      void GetGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) override;
      void CreateGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) override;
      void ApproveGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, std::function<void(::grpc::Status)>) override;
      void DenyGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RevokeGrant(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* AsyncCheckOnboardingStatusRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* PrepareAsyncCheckOnboardingStatusRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* AsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* PrepareAsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* AsyncSearchEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* PrepareAsyncSearchEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>* AsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Entitlement>* PrepareAsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* AsyncListGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* PrepareAsyncListGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* AsyncSearchGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* PrepareAsyncSearchGrantsRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncGetGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncGetGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncCreateGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncCreateGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncApproveGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncApproveGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* AsyncDenyGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::privilegedaccessmanager::v1::Grant>* PrepareAsyncDenyGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRevokeGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRevokeGrantRaw(::grpc::ClientContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CheckOnboardingStatus_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntitlements_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchEntitlements_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_ListGrants_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchGrants_;
    const ::grpc::internal::RpcMethod rpcmethod_GetGrant_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateGrant_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveGrant_;
    const ::grpc::internal::RpcMethod rpcmethod_DenyGrant_;
    const ::grpc::internal::RpcMethod rpcmethod_RevokeGrant_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // CheckOnboardingStatus reports the onboarding status for a
    // project/folder/organization. Any findings reported by this API need to be
    // fixed before PAM can be used on the resource.
    virtual ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response);
    // Lists entitlements in a given project/folder/organization and location.
    virtual ::grpc::Status ListEntitlements(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response);
    // `SearchEntitlements` returns entitlements on which the caller has the
    // specified access.
    virtual ::grpc::Status SearchEntitlements(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response);
    // Gets details of a single entitlement.
    virtual ::grpc::Status GetEntitlement(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response);
    // Creates a new entitlement in a given project/folder/organization and
    // location.
    virtual ::grpc::Status CreateEntitlement(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single entitlement. This method can only be called when there
    // are no in-progress (ACTIVE/ACTIVATING/REVOKING) grants under the
    // entitlement.
    virtual ::grpc::Status DeleteEntitlement(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Updates the entitlement specified in the request. Updated fields in the
    // entitlement need to be specified in an update mask. The changes made to an
    // entitlement are applicable only on future grants of the entitlement.
    // However, if new approvers are added or existing approvers are removed from
    // the approval workflow, the changes are effective on existing grants.
    //
    // The following fields are not supported for updates:
    //
    //  * All immutable fields
    //  * Entitlement name
    //  * Resource name
    //  * Resource type
    //  * Adding an approval workflow in an entitlement which previously had no
    //    approval workflow.
    //  * Deleting the approval workflow from an entitlement.
    //  * Adding or deleting a step in the approval workflow (only one step is
    //    supported)
    //
    // Note that updates are allowed on the list of approvers in an approval
    // workflow step.
    virtual ::grpc::Status UpdateEntitlement(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Lists grants for a given entitlement.
    virtual ::grpc::Status ListGrants(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response);
    // `SearchGrants` returns grants that are related to the calling user in the
    // specified way.
    virtual ::grpc::Status SearchGrants(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response);
    // Get details of a single grant.
    virtual ::grpc::Status GetGrant(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response);
    // Creates a new grant in a given project and location.
    virtual ::grpc::Status CreateGrant(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response);
    // `ApproveGrant` is used to approve a grant. This method can only be called
    // on a grant when it's in the `APPROVAL_AWAITED` state. This operation can't
    // be undone.
    virtual ::grpc::Status ApproveGrant(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response);
    // `DenyGrant` is used to deny a grant. This method can only be called on a
    // grant when it's in the `APPROVAL_AWAITED` state. This operation can't be
    // undone.
    virtual ::grpc::Status DenyGrant(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response);
    // `RevokeGrant` is used to immediately revoke access for a grant. This method
    // can be called when the grant is in a non-terminal state.
    virtual ::grpc::Status RevokeGrant(::grpc::ServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckOnboardingStatus(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlements(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchEntitlements(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntitlement(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::Entitlement>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntitlement(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntitlement(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntitlement(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListGrants() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListGrants(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchGrants() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchGrants(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetGrant() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGrant(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::Grant>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateGrant() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateGrant(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::Grant>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveGrant(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::Grant>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DenyGrant() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDenyGrant(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::privilegedaccessmanager::v1::Grant>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRevokeGrant(::grpc::ServerContext* context, ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CheckOnboardingStatus<WithAsyncMethod_ListEntitlements<WithAsyncMethod_SearchEntitlements<WithAsyncMethod_GetEntitlement<WithAsyncMethod_CreateEntitlement<WithAsyncMethod_DeleteEntitlement<WithAsyncMethod_UpdateEntitlement<WithAsyncMethod_ListGrants<WithAsyncMethod_SearchGrants<WithAsyncMethod_GetGrant<WithAsyncMethod_CreateGrant<WithAsyncMethod_ApproveGrant<WithAsyncMethod_DenyGrant<WithAsyncMethod_RevokeGrant<Service > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* request, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* response) { return this->CheckOnboardingStatus(context, request, response); }));}
    void SetMessageAllocatorFor_CheckOnboardingStatus(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckOnboardingStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* response) { return this->ListEntitlements(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntitlements(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* response) { return this->SearchEntitlements(context, request, response); }));}
    void SetMessageAllocatorFor_SearchEntitlements(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest, ::google::cloud::privilegedaccessmanager::v1::Entitlement>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* request, ::google::cloud::privilegedaccessmanager::v1::Entitlement* response) { return this->GetEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_GetEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest, ::google::cloud::privilegedaccessmanager::v1::Entitlement>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest, ::google::cloud::privilegedaccessmanager::v1::Entitlement>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->CreateEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->DeleteEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->UpdateEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListGrants() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* response) { return this->ListGrants(context, request, response); }));}
    void SetMessageAllocatorFor_ListGrants(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListGrants(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchGrants() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* request, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* response) { return this->SearchGrants(context, request, response); }));}
    void SetMessageAllocatorFor_SearchGrants(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchGrants(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetGrant() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) { return this->GetGrant(context, request, response); }));}
    void SetMessageAllocatorFor_GetGrant(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateGrant() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) { return this->CreateGrant(context, request, response); }));}
    void SetMessageAllocatorFor_CreateGrant(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) { return this->ApproveGrant(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveGrant(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DenyGrant() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* request, ::google::cloud::privilegedaccessmanager::v1::Grant* response) { return this->DenyGrant(context, request, response); }));}
    void SetMessageAllocatorFor_DenyGrant(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DenyGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* request, ::google::longrunning::Operation* response) { return this->RevokeGrant(context, request, response); }));}
    void SetMessageAllocatorFor_RevokeGrant(
        ::grpc::MessageAllocator< ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RevokeGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CheckOnboardingStatus<WithCallbackMethod_ListEntitlements<WithCallbackMethod_SearchEntitlements<WithCallbackMethod_GetEntitlement<WithCallbackMethod_CreateEntitlement<WithCallbackMethod_DeleteEntitlement<WithCallbackMethod_UpdateEntitlement<WithCallbackMethod_ListGrants<WithCallbackMethod_SearchGrants<WithCallbackMethod_GetGrant<WithCallbackMethod_CreateGrant<WithCallbackMethod_ApproveGrant<WithCallbackMethod_DenyGrant<WithCallbackMethod_RevokeGrant<Service > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListGrants() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchGrants() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetGrant() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateGrant() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DenyGrant() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckOnboardingStatus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlements(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchEntitlements(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListGrants() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListGrants(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchGrants() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchGrants(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetGrant() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGrant(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateGrant() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateGrant(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveGrant(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DenyGrant() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDenyGrant(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRevokeGrant(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CheckOnboardingStatus(context, request, response); }));
    }
    ~WithRawCallbackMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckOnboardingStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntitlements(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchEntitlements(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListGrants() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListGrants(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListGrants(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchGrants() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchGrants(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchGrants(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetGrant() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetGrant(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateGrant() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateGrant(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveGrant(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DenyGrant() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DenyGrant(context, request, response); }));
    }
    ~WithRawCallbackMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DenyGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RevokeGrant(context, request, response); }));
    }
    ~WithRawCallbackMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RevokeGrant(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CheckOnboardingStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CheckOnboardingStatus() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* streamer) {
                       return this->StreamedCheckOnboardingStatus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CheckOnboardingStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CheckOnboardingStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCheckOnboardingStatus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusRequest,::google::cloud::privilegedaccessmanager::v1::CheckOnboardingStatusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* streamer) {
                       return this->StreamedListEntitlements(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntitlements(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::ListEntitlementsRequest,::google::cloud::privilegedaccessmanager::v1::ListEntitlementsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchEntitlements() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* streamer) {
                       return this->StreamedSearchEntitlements(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchEntitlements(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsRequest,::google::cloud::privilegedaccessmanager::v1::SearchEntitlementsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest, ::google::cloud::privilegedaccessmanager::v1::Entitlement>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest, ::google::cloud::privilegedaccessmanager::v1::Entitlement>* streamer) {
                       return this->StreamedGetEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::GetEntitlementRequest,::google::cloud::privilegedaccessmanager::v1::Entitlement>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::CreateEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEntitlement() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::DeleteEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEntitlement() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::UpdateEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListGrants() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* streamer) {
                       return this->StreamedListGrants(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListGrants(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::ListGrantsRequest,::google::cloud::privilegedaccessmanager::v1::ListGrantsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchGrants : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchGrants() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* streamer) {
                       return this->StreamedSearchGrants(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchGrants() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchGrants(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchGrants(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::SearchGrantsRequest,::google::cloud::privilegedaccessmanager::v1::SearchGrantsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetGrant() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* streamer) {
                       return this->StreamedGetGrant(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetGrant(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::GetGrantRequest,::google::cloud::privilegedaccessmanager::v1::Grant>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateGrant() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* streamer) {
                       return this->StreamedCreateGrant(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateGrant(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::CreateGrantRequest,::google::cloud::privilegedaccessmanager::v1::Grant>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveGrant() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* streamer) {
                       return this->StreamedApproveGrant(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveGrant(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::ApproveGrantRequest,::google::cloud::privilegedaccessmanager::v1::Grant>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DenyGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DenyGrant() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest, ::google::cloud::privilegedaccessmanager::v1::Grant>* streamer) {
                       return this->StreamedDenyGrant(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DenyGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DenyGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest* /*request*/, ::google::cloud::privilegedaccessmanager::v1::Grant* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDenyGrant(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::DenyGrantRequest,::google::cloud::privilegedaccessmanager::v1::Grant>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RevokeGrant : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RevokeGrant() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRevokeGrant(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RevokeGrant() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RevokeGrant(::grpc::ServerContext* /*context*/, const ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRevokeGrant(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::privilegedaccessmanager::v1::RevokeGrantRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CheckOnboardingStatus<WithStreamedUnaryMethod_ListEntitlements<WithStreamedUnaryMethod_SearchEntitlements<WithStreamedUnaryMethod_GetEntitlement<WithStreamedUnaryMethod_CreateEntitlement<WithStreamedUnaryMethod_DeleteEntitlement<WithStreamedUnaryMethod_UpdateEntitlement<WithStreamedUnaryMethod_ListGrants<WithStreamedUnaryMethod_SearchGrants<WithStreamedUnaryMethod_GetGrant<WithStreamedUnaryMethod_CreateGrant<WithStreamedUnaryMethod_ApproveGrant<WithStreamedUnaryMethod_DenyGrant<WithStreamedUnaryMethod_RevokeGrant<Service > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CheckOnboardingStatus<WithStreamedUnaryMethod_ListEntitlements<WithStreamedUnaryMethod_SearchEntitlements<WithStreamedUnaryMethod_GetEntitlement<WithStreamedUnaryMethod_CreateEntitlement<WithStreamedUnaryMethod_DeleteEntitlement<WithStreamedUnaryMethod_UpdateEntitlement<WithStreamedUnaryMethod_ListGrants<WithStreamedUnaryMethod_SearchGrants<WithStreamedUnaryMethod_GetGrant<WithStreamedUnaryMethod_CreateGrant<WithStreamedUnaryMethod_ApproveGrant<WithStreamedUnaryMethod_DenyGrant<WithStreamedUnaryMethod_RevokeGrant<Service > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace privilegedaccessmanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fprivilegedaccessmanager_2fv1_2fprivilegedaccessmanager_2eproto__INCLUDED
