// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/resourcemanager/v3/tag_keys.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_INTERNAL_TAG_KEYS_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_INTERNAL_TAG_KEYS_TRACING_CONNECTION_H

#include "google/cloud/resourcemanager/v3/tag_keys_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace resourcemanager_v3_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class TagKeysTracingConnection : public resourcemanager_v3::TagKeysConnection {
 public:
  ~TagKeysTracingConnection() override = default;

  explicit TagKeysTracingConnection(
      std::shared_ptr<resourcemanager_v3::TagKeysConnection> child);

  Options options() override { return child_->options(); }

  StreamRange<google::cloud::resourcemanager::v3::TagKey> ListTagKeys(
      google::cloud::resourcemanager::v3::ListTagKeysRequest request) override;

  StatusOr<google::cloud::resourcemanager::v3::TagKey> GetTagKey(
      google::cloud::resourcemanager::v3::GetTagKeyRequest const& request)
      override;

  StatusOr<google::cloud::resourcemanager::v3::TagKey> GetNamespacedTagKey(
      google::cloud::resourcemanager::v3::GetNamespacedTagKeyRequest const&
          request) override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> CreateTagKey(
      google::cloud::resourcemanager::v3::CreateTagKeyRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> CreateTagKey(
      NoAwaitTag,
      google::cloud::resourcemanager::v3::CreateTagKeyRequest const& request)
      override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> CreateTagKey(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> UpdateTagKey(
      google::cloud::resourcemanager::v3::UpdateTagKeyRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> UpdateTagKey(
      NoAwaitTag,
      google::cloud::resourcemanager::v3::UpdateTagKeyRequest const& request)
      override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> UpdateTagKey(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> DeleteTagKey(
      google::cloud::resourcemanager::v3::DeleteTagKeyRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> DeleteTagKey(
      NoAwaitTag,
      google::cloud::resourcemanager::v3::DeleteTagKeyRequest const& request)
      override;

  future<StatusOr<google::cloud::resourcemanager::v3::TagKey>> DeleteTagKey(
      google::longrunning::Operation const& operation) override;

  StatusOr<google::iam::v1::Policy> GetIamPolicy(
      google::iam::v1::GetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::Policy> SetIamPolicy(
      google::iam::v1::SetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::TestIamPermissionsResponse> TestIamPermissions(
      google::iam::v1::TestIamPermissionsRequest const& request) override;

 private:
  std::shared_ptr<resourcemanager_v3::TagKeysConnection> child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<resourcemanager_v3::TagKeysConnection>
MakeTagKeysTracingConnection(
    std::shared_ptr<resourcemanager_v3::TagKeysConnection> conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace resourcemanager_v3_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_INTERNAL_TAG_KEYS_TRACING_CONNECTION_H
