// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/resourcesettings/v1/resource_settings.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fresourcesettings_2fv1_2fresource_5fsettings_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fresourcesettings_2fv1_2fresource_5fsettings_2eproto__INCLUDED

#include "google/cloud/resourcesettings/v1/resource_settings.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace resourcesettings {
namespace v1 {

// An interface to interact with resource settings and setting values throughout
// the resource hierarchy.
//
// Services may surface a number of settings for users to control how their
// resources behave. Values of settings applied on a given Cloud resource are
// evaluated hierarchically and inherited by all descendants of that resource.
//
// For all requests, returns a `google.rpc.Status` with
// `google.rpc.Code.PERMISSION_DENIED` if the IAM check fails or the `parent`
// resource is not in a Cloud Organization.
// For all requests, returns a `google.rpc.Status` with
// `google.rpc.Code.INVALID_ARGUMENT` if the request is malformed.
// (== deprecation_description Resource Settings is deprecated. As of November
// 7, 2023, no organizations will be onboarded for any of the enabled settings,
// and the service will be shut down on October 1, 2024. ==)
class ResourceSettingsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.resourcesettings.v1.ResourceSettingsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all the settings that are available on the Cloud resource `parent`.
    virtual ::grpc::Status ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>> AsyncListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>>(AsyncListSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>> PrepareAsyncListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>>(PrepareAsyncListSettingsRaw(context, request, cq));
    }
    // Gets a setting.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // setting does not exist.
    virtual ::grpc::Status GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::google::cloud::resourcesettings::v1::Setting* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>> AsyncGetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>>(AsyncGetSettingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>> PrepareAsyncGetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>>(PrepareAsyncGetSettingRaw(context, request, cq));
    }
    // Updates a setting.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // setting does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.FAILED_PRECONDITION` if
    // the setting is flagged as read only.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
    // supplied in the request does not match the persisted etag of the setting
    // value.
    //
    // On success, the response will contain only `name`, `local_value` and
    // `etag`.  The `metadata` and `effective_value` cannot be updated through
    // this API.
    //
    // Note: the supplied setting will perform a full overwrite of the
    // `local_value` field.
    virtual ::grpc::Status UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::google::cloud::resourcesettings::v1::Setting* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>> AsyncUpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>>(AsyncUpdateSettingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>> PrepareAsyncUpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>>(PrepareAsyncUpdateSettingRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all the settings that are available on the Cloud resource `parent`.
      virtual void ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a setting.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // setting does not exist.
      virtual void GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a setting.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // setting does not exist.
      // Returns a `google.rpc.Status` with `google.rpc.Code.FAILED_PRECONDITION` if
      // the setting is flagged as read only.
      // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
      // supplied in the request does not match the persisted etag of the setting
      // value.
      //
      // On success, the response will contain only `name`, `local_value` and
      // `etag`.  The `metadata` and `effective_value` cannot be updated through
      // this API.
      //
      // Note: the supplied setting will perform a full overwrite of the
      // `local_value` field.
      virtual void UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>* AsyncListSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::ListSettingsResponse>* PrepareAsyncListSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>* AsyncGetSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>* PrepareAsyncGetSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>* AsyncUpdateSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcesettings::v1::Setting>* PrepareAsyncUpdateSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>> AsyncListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>>(AsyncListSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>> PrepareAsyncListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>>(PrepareAsyncListSettingsRaw(context, request, cq));
    }
    ::grpc::Status GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::google::cloud::resourcesettings::v1::Setting* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>> AsyncGetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>>(AsyncGetSettingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>> PrepareAsyncGetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>>(PrepareAsyncGetSettingRaw(context, request, cq));
    }
    ::grpc::Status UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::google::cloud::resourcesettings::v1::Setting* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>> AsyncUpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>>(AsyncUpdateSettingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>> PrepareAsyncUpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>>(PrepareAsyncUpdateSettingRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSettings(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, std::function<void(::grpc::Status)>) override;
      void GetSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, std::function<void(::grpc::Status)>) override;
      void UpdateSetting(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>* AsyncListSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::ListSettingsResponse>* PrepareAsyncListSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>* AsyncGetSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>* PrepareAsyncGetSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>* AsyncUpdateSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcesettings::v1::Setting>* PrepareAsyncUpdateSettingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSetting_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSetting_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all the settings that are available on the Cloud resource `parent`.
    virtual ::grpc::Status ListSettings(::grpc::ServerContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response);
    // Gets a setting.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // setting does not exist.
    virtual ::grpc::Status GetSetting(::grpc::ServerContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response);
    // Updates a setting.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // setting does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.FAILED_PRECONDITION` if
    // the setting is flagged as read only.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
    // supplied in the request does not match the persisted etag of the setting
    // value.
    //
    // On success, the response will contain only `name`, `local_value` and
    // `etag`.  The `metadata` and `effective_value` cannot be updated through
    // this API.
    //
    // Note: the supplied setting will perform a full overwrite of the
    // `local_value` field.
    virtual ::grpc::Status UpdateSetting(::grpc::ServerContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSettings() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSettings(::grpc::ServerContext* context, ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcesettings::v1::ListSettingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSetting() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSetting(::grpc::ServerContext* context, ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcesettings::v1::Setting>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSetting(::grpc::ServerContext* context, ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcesettings::v1::Setting>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListSettings<WithAsyncMethod_GetSetting<WithAsyncMethod_UpdateSetting<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSettings() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::ListSettingsRequest, ::google::cloud::resourcesettings::v1::ListSettingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* request, ::google::cloud::resourcesettings::v1::ListSettingsResponse* response) { return this->ListSettings(context, request, response); }));}
    void SetMessageAllocatorFor_ListSettings(
        ::grpc::MessageAllocator< ::google::cloud::resourcesettings::v1::ListSettingsRequest, ::google::cloud::resourcesettings::v1::ListSettingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::ListSettingsRequest, ::google::cloud::resourcesettings::v1::ListSettingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSetting() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::GetSettingRequest, ::google::cloud::resourcesettings::v1::Setting>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcesettings::v1::GetSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response) { return this->GetSetting(context, request, response); }));}
    void SetMessageAllocatorFor_GetSetting(
        ::grpc::MessageAllocator< ::google::cloud::resourcesettings::v1::GetSettingRequest, ::google::cloud::resourcesettings::v1::Setting>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::GetSettingRequest, ::google::cloud::resourcesettings::v1::Setting>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSetting(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::UpdateSettingRequest, ::google::cloud::resourcesettings::v1::Setting>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* request, ::google::cloud::resourcesettings::v1::Setting* response) { return this->UpdateSetting(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSetting(
        ::grpc::MessageAllocator< ::google::cloud::resourcesettings::v1::UpdateSettingRequest, ::google::cloud::resourcesettings::v1::Setting>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcesettings::v1::UpdateSettingRequest, ::google::cloud::resourcesettings::v1::Setting>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSetting(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListSettings<WithCallbackMethod_GetSetting<WithCallbackMethod_UpdateSetting<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSettings() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSetting() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSettings() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSetting() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSetting(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSetting(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSettings() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSetting() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSetting(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSetting(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSetting(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSetting(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSettings() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcesettings::v1::ListSettingsRequest, ::google::cloud::resourcesettings::v1::ListSettingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcesettings::v1::ListSettingsRequest, ::google::cloud::resourcesettings::v1::ListSettingsResponse>* streamer) {
                       return this->StreamedListSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::ListSettingsRequest* /*request*/, ::google::cloud::resourcesettings::v1::ListSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcesettings::v1::ListSettingsRequest,::google::cloud::resourcesettings::v1::ListSettingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSetting() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcesettings::v1::GetSettingRequest, ::google::cloud::resourcesettings::v1::Setting>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcesettings::v1::GetSettingRequest, ::google::cloud::resourcesettings::v1::Setting>* streamer) {
                       return this->StreamedGetSetting(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::GetSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSetting(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcesettings::v1::GetSettingRequest,::google::cloud::resourcesettings::v1::Setting>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSetting : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSetting() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcesettings::v1::UpdateSettingRequest, ::google::cloud::resourcesettings::v1::Setting>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcesettings::v1::UpdateSettingRequest, ::google::cloud::resourcesettings::v1::Setting>* streamer) {
                       return this->StreamedUpdateSetting(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSetting() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSetting(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcesettings::v1::UpdateSettingRequest* /*request*/, ::google::cloud::resourcesettings::v1::Setting* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSetting(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcesettings::v1::UpdateSettingRequest,::google::cloud::resourcesettings::v1::Setting>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListSettings<WithStreamedUnaryMethod_GetSetting<WithStreamedUnaryMethod_UpdateSetting<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListSettings<WithStreamedUnaryMethod_GetSetting<WithStreamedUnaryMethod_UpdateSetting<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace resourcesettings
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fresourcesettings_2fv1_2fresource_5fsettings_2eproto__INCLUDED
