// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/video/transcoder/v1/services.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvideo_2ftranscoder_2fv1_2fservices_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvideo_2ftranscoder_2fv1_2fservices_2eproto__INCLUDED

#include "google/cloud/video/transcoder/v1/services.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace video {
namespace transcoder {
namespace v1 {

// Using the Transcoder API, you can queue asynchronous jobs for transcoding
// media into various output formats. Output formats may include different
// streaming standards such as HTTP Live Streaming (HLS) and Dynamic Adaptive
// Streaming over HTTP (DASH). You can also customize jobs using advanced
// features such as Digital Rights Management (DRM), audio equalization, content
// concatenation, and digital ad-stitch ready content generation.
class TranscoderService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.video.transcoder.v1.TranscoderService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a job in the specified region.
    virtual ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::google::cloud::video::transcoder::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    // Lists jobs in the specified region.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // Returns the job data.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::google::cloud::video::transcoder::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Deletes a job.
    virtual ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    // Creates a job template in the specified region.
    virtual ::grpc::Status CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::google::cloud::video::transcoder::v1::JobTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>> AsyncCreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>>(AsyncCreateJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>> PrepareAsyncCreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>>(PrepareAsyncCreateJobTemplateRaw(context, request, cq));
    }
    // Lists job templates in the specified region.
    virtual ::grpc::Status ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>> AsyncListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>>(AsyncListJobTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>> PrepareAsyncListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>>(PrepareAsyncListJobTemplatesRaw(context, request, cq));
    }
    // Returns the job template data.
    virtual ::grpc::Status GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::google::cloud::video::transcoder::v1::JobTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>> AsyncGetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>>(AsyncGetJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>> PrepareAsyncGetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>>(PrepareAsyncGetJobTemplateRaw(context, request, cq));
    }
    // Deletes a job template.
    virtual ::grpc::Status DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobTemplateRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a job in the specified region.
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists jobs in the specified region.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the job data.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a job.
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a job template in the specified region.
      virtual void CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists job templates in the specified region.
      virtual void ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the job template data.
      virtual void GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a job template.
      virtual void DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>* AsyncCreateJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>* PrepareAsyncCreateJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* AsyncListJobTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* PrepareAsyncListJobTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>* AsyncGetJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::transcoder::v1::JobTemplate>* PrepareAsyncGetJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::google::cloud::video::transcoder::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::google::cloud::video::transcoder::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    ::grpc::Status CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::google::cloud::video::transcoder::v1::JobTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>> AsyncCreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>>(AsyncCreateJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>> PrepareAsyncCreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>>(PrepareAsyncCreateJobTemplateRaw(context, request, cq));
    }
    ::grpc::Status ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>> AsyncListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>>(AsyncListJobTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>> PrepareAsyncListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>>(PrepareAsyncListJobTemplatesRaw(context, request, cq));
    }
    ::grpc::Status GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::google::cloud::video::transcoder::v1::JobTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>> AsyncGetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>>(AsyncGetJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>> PrepareAsyncGetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>>(PrepareAsyncGetJobTemplateRaw(context, request, cq));
    }
    ::grpc::Status DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobTemplateRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, std::function<void(::grpc::Status)>) override;
      void CreateJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobTemplates(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, std::function<void(::grpc::Status)>) override;
      void GetJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJobTemplate(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>* AsyncCreateJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>* PrepareAsyncCreateJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* AsyncListJobTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* PrepareAsyncListJobTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>* AsyncGetJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::transcoder::v1::JobTemplate>* PrepareAsyncGetJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateJobTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobTemplates_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJobTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJobTemplate_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a job in the specified region.
    virtual ::grpc::Status CreateJob(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response);
    // Lists jobs in the specified region.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response);
    // Returns the job data.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response);
    // Deletes a job.
    virtual ::grpc::Status DeleteJob(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response);
    // Creates a job template in the specified region.
    virtual ::grpc::Status CreateJobTemplate(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response);
    // Lists job templates in the specified region.
    virtual ::grpc::Status ListJobTemplates(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response);
    // Returns the job template data.
    virtual ::grpc::Status GetJobTemplate(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response);
    // Deletes a job template.
    virtual ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::ListJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJob() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJobTemplate(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::JobTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobTemplates(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobTemplate(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::transcoder::v1::JobTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJobTemplate(::grpc::ServerContext* context, ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateJob<WithAsyncMethod_ListJobs<WithAsyncMethod_GetJob<WithAsyncMethod_DeleteJob<WithAsyncMethod_CreateJobTemplate<WithAsyncMethod_ListJobTemplates<WithAsyncMethod_GetJobTemplate<WithAsyncMethod_DeleteJobTemplate<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::CreateJobRequest, ::google::cloud::video::transcoder::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::CreateJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response) { return this->CreateJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateJob(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::CreateJobRequest, ::google::cloud::video::transcoder::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::CreateJobRequest, ::google::cloud::video::transcoder::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::ListJobsRequest, ::google::cloud::video::transcoder::v1::ListJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::ListJobsRequest* request, ::google::cloud::video::transcoder::v1::ListJobsResponse* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::ListJobsRequest, ::google::cloud::video::transcoder::v1::ListJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::ListJobsRequest, ::google::cloud::video::transcoder::v1::ListJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::GetJobRequest, ::google::cloud::video::transcoder::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::GetJobRequest* request, ::google::cloud::video::transcoder::v1::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::GetJobRequest, ::google::cloud::video::transcoder::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::GetJobRequest, ::google::cloud::video::transcoder::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJob(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::DeleteJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::DeleteJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response) { return this->CreateJobTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateJobTemplate(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* request, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* response) { return this->ListJobTemplates(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobTemplates(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::GetJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* request, ::google::cloud::video::transcoder::v1::JobTemplate* response) { return this->GetJobTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_GetJobTemplate(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::GetJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::GetJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJobTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJobTemplate(
        ::grpc::MessageAllocator< ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateJob<WithCallbackMethod_ListJobs<WithCallbackMethod_GetJob<WithCallbackMethod_DeleteJob<WithCallbackMethod_CreateJobTemplate<WithCallbackMethod_ListJobTemplates<WithCallbackMethod_GetJobTemplate<WithCallbackMethod_DeleteJobTemplate<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJob() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJobTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobTemplates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJobTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateJobTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobTemplates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJobTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJobTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJobTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::CreateJobRequest, ::google::cloud::video::transcoder::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::CreateJobRequest, ::google::cloud::video::transcoder::v1::Job>* streamer) {
                       return this->StreamedCreateJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::CreateJobRequest,::google::cloud::video::transcoder::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::ListJobsRequest, ::google::cloud::video::transcoder::v1::ListJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::ListJobsRequest, ::google::cloud::video::transcoder::v1::ListJobsResponse>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobsRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::ListJobsRequest,::google::cloud::video::transcoder::v1::ListJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::GetJobRequest, ::google::cloud::video::transcoder::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::GetJobRequest, ::google::cloud::video::transcoder::v1::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobRequest* /*request*/, ::google::cloud::video::transcoder::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::GetJobRequest,::google::cloud::video::transcoder::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJob() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::DeleteJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::DeleteJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateJobTemplate() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>* streamer) {
                       return this->StreamedCreateJobTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateJobTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::CreateJobTemplateRequest,::google::cloud::video::transcoder::v1::JobTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobTemplates() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* streamer) {
                       return this->StreamedListJobTemplates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest* /*request*/, ::google::cloud::video::transcoder::v1::ListJobTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobTemplates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::ListJobTemplatesRequest,::google::cloud::video::transcoder::v1::ListJobTemplatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJobTemplate() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::GetJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::GetJobTemplateRequest, ::google::cloud::video::transcoder::v1::JobTemplate>* streamer) {
                       return this->StreamedGetJobTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::GetJobTemplateRequest* /*request*/, ::google::cloud::video::transcoder::v1::JobTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJobTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::GetJobTemplateRequest,::google::cloud::video::transcoder::v1::JobTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJobTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJobTemplate() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJobTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJobTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJobTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJobTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::transcoder::v1::DeleteJobTemplateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_CreateJobTemplate<WithStreamedUnaryMethod_ListJobTemplates<WithStreamedUnaryMethod_GetJobTemplate<WithStreamedUnaryMethod_DeleteJobTemplate<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_CreateJobTemplate<WithStreamedUnaryMethod_ListJobTemplates<WithStreamedUnaryMethod_GetJobTemplate<WithStreamedUnaryMethod_DeleteJobTemplate<Service > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace transcoder
}  // namespace video
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fvideo_2ftranscoder_2fv1_2fservices_2eproto__INCLUDED
